package loan.origination.bureaustrategy;

import com.openrules.core.DecisionModel;
import com.openrules.core.Goal;

import loan.origination.*;

public class BureauStrategyLauncher {

	DecisionModel bureauStrategyModel;
	Goal bureauStrategyGoal;

	public BureauStrategyLauncher() {
		bureauStrategyModel = new BureauStrategy();
		bureauStrategyGoal = bureauStrategyModel.createGoal();
	}

	public static void main(String[] args) {

		long startTime = System.currentTimeMillis();
		
		BureauStrategyLauncher launcher = new BureauStrategyLauncher();

		Applicant[] applicants = applicantsArray.get();
		RequestedProduct[] requestedProducts = requestedProductsArray.get();
		Application[] applications = applicationsArray.get();

		for (int i = 0; i < applications.length; i++) {
			System.out.println("\n" + applications[i].toString());
			launcher.execute(applications[i], applicants[i], requestedProducts[i]);
			System.out.println(
					"\n *** TEST-" + (i + 1) + " Bureau Strategy: " + applications[i].getBureauStrategy() + " ***");
		}

		long endTime = System.currentTimeMillis();
		System.out.println("Total Elapsed time: " + (endTime - startTime + 1) + " ms");

	}

	public void execute(Application application, Applicant applicant, RequestedProduct requestedProduct) {
		bureauStrategyGoal.use("Application", application);
		bureauStrategyGoal.use("Applicant", applicant);
		bureauStrategyGoal.use("RequestedProduct", requestedProduct);
		bureauStrategyGoal.execute();
	}
}
