package loan.origination.routing;

import com.openrules.core.DecisionModel;
import com.openrules.core.Goal;

import loan.origination.*;

public class RoutingLauncher {

	DecisionModel routingModel;
	Goal routingGoal;

	public RoutingLauncher() {
		 routingModel = new Routing();
		routingGoal = routingModel.createGoal();
	}
	
	public void execute(Application application, Applicant applicant, RequestedProduct requestedProduct, BureauData bureauData) {
		routingGoal.use("Application", application);
		routingGoal.use("Applicant", applicant);
		routingGoal.use("RequestedProduct", requestedProduct);
		routingGoal.use("BureauData", bureauData);
		routingGoal.execute();
		System.out.println("Routing: " + application.getRouting() + " ***");
	}

	public static void main(String[] args) {

		long startTime = System.currentTimeMillis();
		
		RoutingLauncher launcher = new RoutingLauncher();

		Applicant[] applicants = applicantsArray.get();
		RequestedProduct[] requestedProducts = requestedProductsArray.get();
		Application[] applications = applicationsArray.get();
		BureauData[] bureauData =  bureauDataArray.get();

		for (int i = 0; i < applications.length; i++) {
			System.out.println("\n*** TEST-" + (i + 1) + applications[i].toString());
			launcher.execute(applications[i], applicants[i], requestedProducts[i],bureauData[i]);
		}
		long endTime = System.currentTimeMillis();
		System.out.println("Total Elapsed time: " + (endTime - startTime + 1) + " ms");

	}
}
